
import os
import json
import numpy
class Can_See
	def is_pos_valid(self, pos):
        """
        坐标是否在地图有效范围内
        :param pos:
        :return:
        """
        return 0 <= pos // 100 < self.map_row and 0 <= pos % 100 < self.map_col
   
	def visibility(self, pos1, pos2, mod):
        """
        判断两个位置是否通视
        :param mod: 0 1 2 3地对地，空对空，空对地，地对空
        :param pos1:
        :param pos2:
        :return:
        """
        try:
            if not self.is_pos_valid(pos1) or not self.is_pos_valid(
                pos2
            ):
                return False
            see_data = self.get_see_data()
            if mod in [0, 1, 2]:
                row1, col1 = divmod(pos1, 100)
                row2, col2 = divmod(pos2, 100)
            else:
                row1, col1 = divmod(pos2, 100)
                row2, col2 = divmod(pos1, 100)
                mod = 2
            return True if see_data[mod][row1, col1, row2, col2] else False
        except Exception as e:
            raise e
	def get_see_data(self):
        return self.See_Data
	def load(self):
        try:
            with open(
                os.path.join(self.path_dir, "map.json"), "r", encoding="utf8"
            ) as fp:
                json_data = json.load(fp)
                self.map_data = json_data
                map_row = json_data["map_row"]
                map_col = json_data["map_col"]
                state_data = json_data["state_data"]
                for i in range(map_row):
                    print(i)
                    self.basic_map.append([])
                    for j in range(map_col):
                        data = state_data[i][j]
                        cost = data["cost"][0]
                        neighbors = []
                        for key, item in cost.items():
                            neighbors.append(int(key))
                        self.basic_map[i].append(
                            {
                                "pos": data["pos"],
                                "elev": data["elev"],
                                "cond": data["cond"],
                                "roads": data["roads"],
                                "rivers": data["rivers"],
                                "neighbors": data["neighbors"],
                            }
                        )
            self.See_Data = numpy.load(os.path.join(self.path_dir, "see.npz"))["data"]
        except Exception as e:
            raise e
		
	